Ext.define('DSS.component.ComboboxControl', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    cboCombo:null,
    cboStore:null,
    fillCombo: function(config) {
        if (config.storeid!=null)
        	this.cboStore=Ext.data.StoreManager.lookup(config.storeid);
        else
            if (config.data!=null) {
            	this.cboStore=Ext.create('Ext.data.Store', {
                    fields : [  config.storevalueid, config.storedisplayid],
                    proxy : {
                        type : 'memory',
                        reader : {
                            type : 'json',
                            root : 'items'
                        }
                    }
                });
            	for (var iIndex=0;iIndex<config.data.length;iIndex++) {
            		var pValue=config.data[iIndex];
            		if (pValue[config.storevalueid]!=null)
            			if (pValue[config.storedisplayid]!=null) {
            				var newValue={};
            				newValue[config.storevalueid]=""+pValue[config.storevalueid];
            				newValue[config.storedisplayid]=""+pValue[config.storedisplayid];
            				this.cboStore.add([newValue]);
            			}
            	}
            }
    },
    constructor : function(config) {
    	var mThis=this;
    	if (config.labelWidth==null)
    		config.labelWidth=100;
        if (config.allowBlank==null) {
            config.allowBlank = true;
        }
    	this.fillCombo(config);
        this.cboCombo = Ext.create('Ext.form.field.ComboBox', {
            store: this.cboStore,
            queryMode: 'local',
            displayField: config.storedisplayid,
            valueField: config.storevalueid,
            fieldLabel : config.label,
            labelWidth:config.labelWidth,
            width : (700 - config.labelWidth),
            editable:false,
            allowBlank : config.allowBlank,
            listeners: {
            	'change': function() {mThis.fireEvent('change');},
                render: function (obj) {
                    Ext.get(obj.id + '-labelEl').on('click', function (e) {
                        e.preventDefault();
                    });
                }
            }
        });
        Ext.data.StoreManager.on('clear',function () {mThis.fillCombo(config);});
        Ext.apply(this, {
            items : [ this.cboCombo  ]
        });

        this.callParent(arguments);
    },
    reset: function (){
    	this.cboCombo.reset();
    },
    setValue:function (value){
    	this.cboCombo.setValue("" + value);
    },
    isValid:function(){
        return this.cboCombo.isValid();
    },
    getValue : function(){
    	return this.cboCombo.getValue();
    }
});
