/**
 * ist bloed, muss aber wegen sonderzeichen sein
 */

Ext.define('DSS.component.Dateedit', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    oDatePanel:null,
    oControlDate:null,
    oControlHour:null,
    oControlMinute:null,
    iDefaultDate:null,
    constructor : function(config){
    	if (config.labelWidth==null)
    		config.labelWidth=100;

        this.oDatePanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : config.fieldLabel,
            labelWidth : config.labelWidth,
            border : 1,
            layout : 'column'
        });
        this.oControlDate = Ext.create('Ext.form.field.Date', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            format : 'd.m.Y',
            width : 91,
            margin : '0 10 0 0'
        });
        addDataIdToElement(this.oControlDate, 'Date');

        this.oControlHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel : _('Time of day'),
            width : 121,
            labelWidth : 71,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23,
            allowDecimals : false,
            autoStripChars:true,
            minText: _("The minimum value for hour is 0"),
            maxText: _("The maximum value for hour is 23")
        });
        addDataIdToElement(this.oControlHour, 'Hour');
        this.oControlMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            value : 0,
            margin : '0 5 0 0',
            minValue : 0,
            maxValue : 59,
            allowDecimals : false,
            autoStripChars:true,
            minText: _("The minimum value for minute is 0"),
            maxText: _("The maximum value for minute is 59")
        });
        addDataIdToElement(this.oControlMinute, 'Minute');

        this.oDatePanel.add(this.oControlDate);
        this.oDatePanel.add(this.oControlHour);
        this.oDatePanel.add(this.oControlMinute);
        this.oDatePanel.add(Ext.create('Ext.form.Label', {
            text : '(hh:mm)',
            align : 'middle',
            margin : '3 0 0 0'
        }));
        this.iDefaultDate= new Date();
        this.iDefaultDate.setHours(12);
        this.iDefaultDate.setMinutes(0);
        if (config.defaultValue!=null)
            this.iDefaultDate=config.defaultValue;

        Ext.apply(this, {
            items : [ this.oDatePanel ]
        });
        this.callParent(arguments);
    },
    reset: function (){
        this.oControlHour.setValue(this.iDefaultDate.getHours());
        this.oControlMinute.setValue(this.iDefaultDate.getMinutes());
        this.oControlDate.setValue(this.iDefaultDate);
    },
    setValue:function (value){
    	var timeString = value.match(/..:..:../);
    	var timeArray = timeString[0].split(":");
        this.oControlHour.setValue(timeArray[0]);
        this.oControlMinute.setValue(timeArray[1]);
        this.oControlDate.setValue(new Date(value));
    },
    isValid:function(){
        return this.oControlDate.isValid() && this.oControlMinute.isValid() && this.oControlHour.isValid();
    },
    getValue : function(){
        var oDate=this.oControlDate.getValue();
        oDate.setHours(this.oControlHour.getValue());
        oDate.setMinutes(this.oControlMinute.getValue());
        return oDate;
    }
});
