Ext.define('DSS.component.TimeReference', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    oDatePanel:null,
    oLimitPanel:null,
    oDeltaCylcer:null,
    oDateTypeCylcer :null,
    oControlHour :null,
    oControlMinute:null,
    lblAnzeige:null,
    oLimitType:null,
    oLimitHour:null,
    oLimitMinute:null,
    lblLimitAnzeige:null,
    lblSummary:null,
    oControlRandom:null,
    pnlDiff:null,
    randomize:null,
    referenceChangeListener:null,
    fAlternativeDisplay:false,
    fFeatureEnabled : {
      fStaticEnabled:true,
      fDuskEnabled:true,
      fDawnEnabled:true,
      fSunsetEnabled:true,
      fSunriseEnabled:true
    },
    constructor : function (config) {
        var me=this;
        this.fAlternativeDisplay=false;
    	if (config.labelWidth==null)
    		config.labelWidth=80;
        this.fFeatureEnabled.fStaticEnabled=true;
        this.fFeatureEnabled.fDuskEnabled=true;
        this.fFeatureEnabled.fDawnEnabled=true;
        this.fFeatureEnabled.fSunsetEnabled=true;
        this.fFeatureEnabled.fSunriseEnabled=true;

        if (config.fFeatureEnabled!=null) {
            if (config.fFeatureEnabled.fStaticEnabled!=null)
                this.fFeatureEnabled.fStaticEnabled=config.fFeatureEnabled.fStaticEnabled;
            if (config.fFeatureEnabled.fDuskEnabled!=null)
                this.fFeatureEnabled.fDuskEnabled=config.fFeatureEnabled.fDuskEnabled;
            if (config.fFeatureEnabled.fDawnEnabled!=null)
                this.fFeatureEnabled.fDawnEnabled=config.fFeatureEnabled.fDawnEnabled;
            if (config.fFeatureEnabled.fSunsetEnabled!=null)
                this.fFeatureEnabled.fSunsetEnabled=config.fFeatureEnabled.fSunsetEnabled;
            if (config.fFeatureEnabled.fSunriseEnabled!=null)
                this.fFeatureEnabled.fSunriseEnabled=config.fFeatureEnabled.fSunriseEnabled;
        }

        if (config.fAlternativeDisplay!=null)
            this.fAlternativeDisplay=config.fAlternativeDisplay;
        if (this.fAlternativeDisplay==true) {
            this.lblSummary = Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                value:'(hh:mm)',
                width:250,
                padding: "0 0 0 0"
            });

        } else {
            this.lblSummary = Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                value:'(hh:mm)',
                width:600,
                padding: "0 0 7 10"
            });
        }
        this.lblAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'(hh:mm)',
            margin: "0 10 0 0"
        });
        this.lblLimitAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:_("o'clock"),
            hidden:true
        });
        this.oDatePanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : config.label,
            labelWidth : config.labelWidth,
            border : 1,
            margin : '0 0 0 10',
            layout : 'column'
        });
        this.oLimitPanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : "&#160;",
            labelSeparator:'',
            labelWidth : config.labelWidth,
            border : 1,
            layout : 'column',
            padding: "5 0 0 0"
        });
        this.randomize=config.randomize;
        if (this.randomize) {
            this.oControlRandom = Ext.create(
                    'Ext.form.field.Checkbox',
                    {   labelWidth : config.labelWidth+10,
                        labelSeparator:'',
                        fieldLabel:'&nbsp;',
                        boxLabel : _('randomize Time with &plusmn;15 minutes'),
                        padding: "6 0 0 0"
                    });
        }
        if (config.referenceChangeListener!=null)
            this.referenceChangeListener=config.referenceChangeListener;
        else
            this.referenceChangeListener=null;
        this.oLimitType = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 10',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-limitNo',
                    text : _('no restrictions')
                },{
                    itemId : 'chk-limitBefore',
                    text : _('not later than')
                }, {
                    itemId : 'chk-limitAfter',
                    text :  _('not before')
                } ]
            },
            listeners: {
                change: function(btn,item) {
                    btn.up().up().oLimitHour.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().oLimitMinute.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().lblLimitAnzeige.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().oLimitHour.setValue(0);
                    btn.up().up().oLimitMinute.setValue(0);
                }
            },
            showText : true,
            width : 150
        });
        this.oLimitHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 43,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23,
            allowDecimals : false,
            autoStripChars:true,
            minText: _("The minimum value for hour is 0"),
            maxText: _("The maximum value for hour is 23"),
            hidden:true,
            listeners: {
                change : function () {
                    me.fireEvent('change');
                }
            }

        });
        this.oLimitMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            margin : '0 5 0 0',
            value : 0,
            minValue : 0,
            maxValue : 59,
            allowDecimals : false,
            autoStripChars:true,
            minText: _("The minimum value for minute is 0"),
            maxText: _("The maximum value for minute is 59"),
            hidden:true,
            listeners: {
                change : function () {
                    me.fireEvent('change');
                }
            }

        });

        this.oDeltaCylcer= Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-before',
                    text : _('earlier')
                }, {
                    itemId : 'chk-after',
                    text : _('later')

                } ]
            },
            showText : true,
            width : 100,
            hidden:true,
            listeners: {
                change : function () {
                    me.fireEvent('change');
                }
            }

        });


        var oDateTypeItemArray = [];
        var fChecked=false;
        if (this.fFeatureEnabled.fStaticEnabled) {
        	fChecked=true;
            oDateTypeItemArray.push({
                checked : true,
                itemId : 'chk-time',
                text : _('fixed time')
            });
        }
        if (this.fFeatureEnabled.fSunriseEnabled)
        {
            var oObject={
                itemId : 'chk-sunrise',
                text : _('sunrise')
            };
            if (!fChecked )
                oObject.checked=true;
            fChecked=true;
            oDateTypeItemArray.push(oObject);
        }
        if (this.fFeatureEnabled.fSunsetEnabled)
        {
            var oObject={
                itemId : 'chk-sunset',
                text : _('sunset')
            };
            if (!fChecked )
                oObject.checked=true;
            fChecked=true;
            oDateTypeItemArray.push(oObject);
        }
        if (this.fFeatureEnabled.fDawnEnabled)
        {
            var oObject={
                itemId : 'chk-dawn',
                text : _('dawn')
            };
            if (!fChecked )
                oObject.checked=true;
            fChecked=true;
            oDateTypeItemArray.push(oObject);
        }
        if (this.fFeatureEnabled.fDuskEnabled)
        {
            var oObject={
                itemId : 'chk-dusk',
                text : _('dusk')
            };
            if (!fChecked )
                oObject.checked=true;
            fChecked=true;
            oDateTypeItemArray.push(oObject);
        }

        if (config.additionalAbsoluteValues) {
            for (var iIndex=0;iIndex<config.additionalAbsoluteValues.length;iIndex++) {
                oDateTypeItemArray.push({itemId:config.additionalAbsoluteValues[iIndex].id,
                                         text: _(config.additionalAbsoluteValues[iIndex].label)});
            }
        }

        this.oDateTypeCylcer = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : oDateTypeItemArray
            },
            showText : true,
            width : 150,
            disabled: (oDateTypeItemArray.length==1),
            listeners : {
                change : function(btn,item) {
                    var basePanel=this.up().up();
                    if ((basePanel.oDeltaCylcer.isVisible()) && (item.getItemId()=='chk-time')){
                        basePanel.oControlHour.setValue(12);
                        basePanel.oControlMinute.setValue(0);
                    }
                    if ((!basePanel.oDeltaCylcer.isVisible()) && (item.getItemId()!='chk-time')){
                        basePanel.oControlHour.setValue(0);
                        basePanel.oControlMinute.setValue(0);
                    }
                    basePanel.oDeltaCylcer.setVisible(item.getItemId()!='chk-time');
                    basePanel.oLimitPanel.setVisible(item.getItemId()!='chk-time');
                    basePanel.doLayout();
                    basePanel.updateSummary();
                    if (basePanel.referenceChangeListener!=null)
                        basePanel.referenceChangeListener(basePanel.dssEditor,basePanel,item.getItemId());
                    basePanel.fireEvent('change');
                }
            }
        });

        this.oControlHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 43,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23,
            allowDecimals : false,
            autoStripChars:true,
            minText: _("The minimum value for hour is 0"),
            maxText: _("The maximum value for hour is 23"),
            listeners: {
                change : function () {
                    me.fireEvent('change');
                }
            }
        });
        this.oControlMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            margin : '0 5 0 0',
            value : 0,
            minValue : 0,
            maxValue : 59,
            allowDecimals : false,
            autoStripChars:true,
            minText: _("The minimum value for minute is 0"),
            maxText: _("The maximum value for minute is 59"),
            listeners: {
                change : function () {
                    me.fireEvent('change');
                }
            }
        });


        this.pnlDiff = Ext.create('Ext.panel.Panel', {
            heigth : 0,
            border : "1 0 0 0",
            width : "100%",
            padding: "7 0 15 0"
         });

        this.oLimitPanel.add(this.oLimitType);
        this.oLimitPanel.add(this.oLimitHour);
        this.oLimitPanel.add(this.oLimitMinute);
        if (!this.fAlternativeDisplay)
            this.oLimitPanel.add(this.lblLimitAnzeige);
        else
            this.oLimitPanel.add(this.lblSummary);

        this.oDatePanel.add(this.oDateTypeCylcer);
        this.oDatePanel.add(this.oControlHour);
        this.oDatePanel.add(this.oControlMinute);
        this.oDatePanel.add(this.lblAnzeige);

        this.oDatePanel.add(this.oDeltaCylcer);
        var oItemsArray=[this.lblSummary, this.pnlDiff, this.oDatePanel ,this.oLimitPanel];

        if (this.fAlternativeDisplay==true)
            oItemsArray=[ this.oDatePanel ,this.oLimitPanel];

        if (this.randomize!=null)
            oItemsArray.push(this.oControlRandom);
        Ext.apply(this, {
            items : oItemsArray
        });
        if (this.fAlternativeDisplay==true)
            Ext.apply(this, {
                padding: "7 0 7 0"
            });
        var me=this;
        var oReplay=function() {me.updateSummary();};

        window.setInterval(oReplay,30*1000);
        me.updateSummary();
        this.callParent(arguments);
        this.mixins.observable.constructor.call(this, config);
        this.addEvents({
            "change" : true
        });
    },
    updateSummary:function(){
    	var sTimeNow = "";
    	var timeArray = new Array();
    	var sText = "";

        var oDateNow=dss.staticDataModel.getDSSTime();
        var nHours = oDateNow.getHours();
        var nMinutes = oDateNow.getMinutes();
        sTimeNow = ((nHours > 9)?''+nHours : '0'+nHours) + ":" + ((nMinutes > 9)?''+nMinutes : '0'+nMinutes);

    	sText=Ext.String.format2(_("Time now: {TimeNow}"), {TimeNow:sTimeNow});
        if (this.fAlternativeDisplay==true) {
            sText=_("");
        }
        switch (this.oDateTypeCylcer.getActiveItem().getItemId()) {
            case 'chk-sunrise':
                sText+=" " + Ext.String.format2(_("Sunrise of the present day at {time}"),{time:dss.staticDataModel.nowSunrise});
                break;
            case 'chk-sunset':
                sText+=" " + Ext.String.format2(_("Sunset of the present day at {time}"),{time:dss.staticDataModel.nowSunset});
                break;
            case 'chk-dawn':
                sText+=" " + Ext.String.format2(_("Dawn of the present day at {time}"),{time:dss.staticDataModel.nowDawn});
                break;
            case 'chk-dusk':
                sText+=" " + Ext.String.format2(_("Dusk of the present day at {time}"),{time:dss.staticDataModel.nowDusk});
                break;
        }
        this.lblSummary.setValue(sText);
    },
    reset:function(){
        this.oDateTypeCylcer.setActiveItem('chk-time');
        this.oLimitType.setActiveItem('chk-limitNo');
        this.oDeltaCylcer.setActiveItem('chk-after');
        this.oControlHour.setValue(12);
        this.oControlMinute.setValue(0);
        this.oLimitHour.setValue(0);
        this.oLimitMinute.setValue(0);
        if (this.randomize!=null)
            this.oControlRandom.setValue(false);
    },
    setValue:function (value) {
        var sec = Math.abs(value.offset%60);
        var min = Math.floor(Math.abs(value.offset) / 60) % 60;
        var hou = Math.floor(Math.abs(value.offset) / 3600);
        if (value.offset<0)
            this.oDeltaCylcer.setActiveItem('chk-before');
        else
            this.oDeltaCylcer.setActiveItem('chk-after');
        switch (value.timeBase)
        {
            case 'daily':
                this.oDateTypeCylcer.setActiveItem('chk-time');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);
            break;
            case 'sunset':
                this.oDateTypeCylcer.setActiveItem('chk-sunset');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);
            break;
            case 'sunrise':
                this.oDateTypeCylcer.setActiveItem('chk-sunrise');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);
            break;
            case 'dusk':
                this.oDateTypeCylcer.setActiveItem('chk-dusk');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);
            break;
            case 'dawn':
                this.oDateTypeCylcer.setActiveItem('chk-dawn');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);
            break;
            default:
                this.oDateTypeCylcer.setActiveItem(value.timeBase);
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);
            break;
        }

        if (value.limitAfter!=null)
        {
            this.oLimitType.setActiveItem('chk-limitAfter');
            var secLimit = Math.abs(value.limitAfter%60);
            var minLimit = Math.floor(Math.abs(value.limitAfter) / 60) % 60;
            var houLimit = Math.floor(Math.abs(value.limitAfter) / 3600);
            this.oLimitMinute.setValue(minLimit);
            this.oLimitHour.setValue(houLimit);
        } else if (value.limitBefore!=null)
        {
            this.oLimitType.setActiveItem('chk-limitBefore');
            var secLimit = Math.abs(value.limitBefore%60);
            var minLimit = Math.floor(Math.abs(value.limitBefore) / 60) % 60;
            var houLimit = Math.floor(Math.abs(value.limitBefore) / 3600);
            this.oLimitMinute.setValue(minLimit);
            this.oLimitHour.setValue(houLimit);
        } else {
            this.oLimitType.setActiveItem('chk-limitNo');
        }

        if (this.randomize!=null) {
            if (value.random!=null)
                this.oControlRandom.setValue(true);
            else
                this.oControlRandom.setValue(false);
        }
    },
    isValid: function () {
    	var sDate=this.oDateTypeCylcer.getActiveItem().getItemId();
    	var fValid=false;
        switch(sDate)
        {
        	case 'chk-time':
        		return this.oControlHour.isValid() && this.oControlMinute.isValid();
        	break;
        	case 'chk-sunrise':
            case 'chk-sunset':
            case 'chk-dusk':
            case 'chk-dawn':
            	fValid= this.oControlHour.isValid() && this.oControlMinute.isValid();
            break;
        }
        if (this.oLimitType.getActiveItem().getItemId()=='chk-limitAfter') {
        	fValid &= this.oLimitHour.isValid() && this.oLimitMinute.isValid();
        }
        if (this.oLimitType.getActiveItem().getItemId()=='chk-limitBefore') {
        	fValid &= this.oLimitHour.isValid() && this.oLimitMinute.isValid();
        }

        return true;
    },
    getValue: function () {
        var oValue={};
        oValue.offset=this.oControlHour.getValue()*3600;
        oValue.offset+=this.oControlMinute.getValue()*60;
        var sDate=this.oDateTypeCylcer.getActiveItem().getItemId();
        switch(sDate)
        {
            case 'chk-time':
                oValue.timeBase='daily';
                break;
            case 'chk-sunset':
                oValue.timeBase='sunset';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-sunrise':
                oValue.timeBase='sunrise';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-dusk':
                oValue.timeBase='dusk';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-dawn':
                oValue.timeBase='dawn';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            default:
                oValue.timeBase=sDate;
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
        }
        if (this.oLimitType.getActiveItem().getItemId()=='chk-limitAfter') {
            oValue.limitAfter=this.oLimitMinute.getValue()*60;
            oValue.limitAfter+=this.oLimitHour.getValue()*3600;
        } else if (this.oLimitType.getActiveItem().getItemId()=='chk-limitBefore') {
            oValue.limitBefore=this.oLimitMinute.getValue()*60;
            oValue.limitBefore+=this.oLimitHour.getValue()*3600;
        }
        if (this.randomize!=null) {
            if (this.oControlRandom.getValue())
                oValue.random=this.randomize;
        }
        return oValue;
    }
});
