/**
 * @class DSS.component.WeekdaySelection
 * @extends Ext.container.ButtonGroup A selector that shows every day of the week as button
 */

Ext.define('DSS.component.WeekdaySelection', {
    extend : 'Ext.form.FieldContainer',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    oControlDate:null,
    oControlType:null,
    lblAnzeige:null,
    oControlMO:null,
    oControlDI:null,
    oControlMI:null,
    oControlDO:null,
    oControlFR:null,
    oControlSA:null,
    oControlSO:null,
    fOnlyWeekdays:false,
    setHeight:function(iHeight) {

    },
    updateDisplay:function(){
        var fMo=this.up().oControlMO.pressed;
        var fDi=this.up().oControlDI.pressed;
        var fMi=this.up().oControlMI.pressed;
        var fDo=this.up().oControlDO.pressed;
        var fFr=this.up().oControlFR.pressed;
        var fSa=this.up().oControlSA.pressed;
        var fSo=this.up().oControlSO.pressed;
        var sText="";
        var sSingular="";
        var iCount=0;
        if (fMo) {
            iCount++;
            sText+=_('MO') + ', ';
            sSingular=_('on monday');
        }

        if (fDi) {
            iCount++;
            sText+=_('TU') + ', ';
            sSingular=_('on tuesday');
        }

        if (fMi) {
            iCount++;
            sText+=_('WE') + ', ';
            sSingular=_('on wednesday');
        }

        if (fDo) {
            iCount++;
            sText+=_('TH') + ', ';
            sSingular=_('on thursday');
        }

        if (fFr) {
            iCount++;
            sText+=_('FR') + ', ';
            sSingular=_('on friday');
        }

        if (fSa) {
            iCount++;
            sText+=_('SA') + ', ';
            sSingular=_('on saturday');
        }

        if (fSo) {
            iCount++;
            sText+=_('SU') + ', ';
            sSingular=_('on sunday');
        }

        if (iCount==2)
            if (fSa)
                if (fSo) {
                    sText=_("on weekends") + ', ';
                }
        if (iCount==5)
            if (!fSa)
                if (!fSo) {
                    sText=_("MO-FR") + ', ';
                    sSingular="";
                }
        if (iCount==7) {
            sText= _("daily") + ', ';
            sSingular="";
        }
        if (iCount==0)
            this.up().lblAnzeige.setValue('(<span style="color:#ff0000;">' + _('no weekdays selected') + '</span>)');
        else
        if (iCount==1)
            this.up().lblAnzeige.setValue("("+sSingular+")");
        else
            this.up().lblAnzeige.setValue("("+sText.substring(0,sText.length-2)+")");
        this.up().fireEvent('change',this.up().getValue());
    },
    constructor : function (config) {
        if (config.fOnlyWeekdays!=null)
            this.fOnlyWeekdays=config.fOnlyWeekdays;

        this.lblAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            width:200,
            height:18
        });
        this.oControlType = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-weekly',
                    text : _('weekly event')
                }, {
                    itemId : 'chk-static',
                    text : _('static date')

                } ]
            },
            showText : true,
            width : 180,
            listeners: {
                change: function(btn,item) {
                    btn.up().toggleRecurring((item.getItemId()=='chk-weekly'));
                }
            }
        });

        this.oControlMO = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("MO"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        this.oControlDI = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("TU"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        this.oControlMI = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("WE"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        this.oControlDO = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("TH"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        this.oControlFR = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("FR"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        this.oControlSA = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("SA"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        this.oControlSO = Ext.create('Ext.button.Button', {
            width : 26,
            margin : '0 3 0 0',
            text : _("SU"),
            enableToggle : true,
            listeners: {toggle:this.updateDisplay}
        });
        addDataIdToElement(this.oControlMO, 'Monday', 'weekday');
        addDataIdToElement(this.oControlDI, 'Tuesday', 'weekday');
        addDataIdToElement(this.oControlMI, 'Wednesday', 'weekday');
        addDataIdToElement(this.oControlDO, 'Thursday', 'weekday');
        addDataIdToElement(this.oControlFR, 'Friday', 'weekday');
        addDataIdToElement(this.oControlSA, 'Saturday', 'weekday');
        addDataIdToElement(this.oControlSO, 'Sunday', 'weekday');

        this.oControlDate = Ext.create('Ext.form.field.Date', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            format : 'd.m.Y',
            width : 91,
            margin : '0 10 0 0',
            hidden:true
        });
    	if (config.labelWidth==null)
    		config.labelWidth=80;
        if (this.fOnlyWeekdays==true) {
            Ext.apply(this, {
                fieldLabel : config.label,
                labelWidth : config.labelWidth,
                border : 1,
                layout :{type: 'hbox',align:'top'},
                margin : '10 0 0 10',
                items : [this.oControlMO, this.oControlDI, this.oControlMI, this.oControlDO, this.oControlFR, this.oControlSA, this.oControlSO,this.lblAnzeige]
            });
        } else {
            Ext.apply(this, {
                fieldLabel : config.label,
                labelWidth : config.labelWidth,
                border : 1,
                layout :{type: 'hbox',align:'top'},
                margin : '10 0 0 10',
                items : [this.oControlType, this.oControlMO, this.oControlDI, this.oControlMI, this.oControlDO, this.oControlFR, this.oControlSA, this.oControlSO,this.lblAnzeige,this.oControlDate]
            });
        }
        this.callParent(arguments);
        this.mixins.observable.constructor.call(this, config);
        this.addEvents({
            "change" : true
        });
    },
    reset: function (){
        this.toggleRecurring(true);
        this.oControlMO.toggle(true);
        this.oControlDI.toggle(true);
        this.oControlMI.toggle(true);
        this.oControlDO.toggle(true);
        this.oControlFR.toggle(true);
        this.oControlSA.toggle(true);
        this.oControlSO.toggle(true);
    },
    toggleRecurring: function (fWeekdayRec){
        var currentDate = new Date();
        this.oControlDate.setMinValue(currentDate);
        this.oControlDate.setVisible(!fWeekdayRec);
        this.lblAnzeige.setVisible(fWeekdayRec);
        this.oControlMO.setVisible(fWeekdayRec);
        this.oControlDI.setVisible(fWeekdayRec);
        this.oControlMI.setVisible(fWeekdayRec);
        this.oControlDO.setVisible(fWeekdayRec);
        this.oControlFR.setVisible(fWeekdayRec);
        this.oControlSA.setVisible(fWeekdayRec);
        this.oControlSO.setVisible(fWeekdayRec);
        this.doLayout();
    },
    setValue:function (value){
        if (value.recurrenceBase=="absolute") {
            this.toggleRecurring(false);
            this.oControlType.setActiveItem('chk-static');
            if (value.timeArray && value.timeArray.length) {
                this.oControlDate.setValue(new Date(value.timeArray[0]));
            }
        } else {
            this.toggleRecurring(true);
            if (!this.fOnlyWeekdays)
                this.oControlType.setActiveItem('chk-weekly');
            this.oControlMO.toggle(false);
            this.oControlDI.toggle(false);
            this.oControlMI.toggle(false);
            this.oControlDO.toggle(false);
            this.oControlFR.toggle(false);
            this.oControlSA.toggle(false);
            this.oControlSO.toggle(false);
            if (value.timeArray) {
                for ( var jIndex = 0; jIndex < value.timeArray.length; jIndex++) {
                    var dataFragment=value.timeArray[jIndex];
                    if (dataFragment == 'MO')
                        this.oControlMO.toggle(true);
                    if (dataFragment == 'TU')
                        this.oControlDI.toggle(true);
                    if (dataFragment == 'WE')
                        this.oControlMI.toggle(true);
                    if (dataFragment == 'TH')
                        this.oControlDO.toggle(true);
                    if (dataFragment == 'FR')
                        this.oControlFR.toggle(true);
                    if (dataFragment == 'SA')
                        this.oControlSA.toggle(true);
                    if (dataFragment == 'SU')
                        this.oControlSO.toggle(true);
                }
            }
        }
    },
    isValid:function() {
        if (this.oControlType.getActiveItem().getItemId()=="chk-static") {
            return this.oControlDate.validate();
        } else {
            if (this.oControlMO.pressed)
                return true;
            if (this.oControlDI.pressed)
                return true;
            if (this.oControlMI.pressed)
                return true;
            if (this.oControlDO.pressed)
                return true;
            if (this.oControlFR.pressed)
                return true;
            if (this.oControlSA.pressed)
                return true;
            if (this.oControlSO.pressed)
                return true;
        }
        return false;
    },
    getValue : function(){
        var oValue=null;
        if (this.oControlType.getActiveItem().getItemId()=="chk-static") {
            oValue={timeArray:[],recurrenceBase:"absolute"};
            oValue.timeArray.push(Ext.Date.format(this.oControlDate.getValue(), "Y-m-d"));
        } else {
           oValue={timeArray:[],recurrenceBase:"weekly"};
           if (this.oControlMO.pressed)
               oValue.timeArray.push('MO');
           if (this.oControlDI.pressed)
               oValue.timeArray.push('TU');
           if (this.oControlMI.pressed)
               oValue.timeArray.push('WE');
           if (this.oControlDO.pressed)
               oValue.timeArray.push('TH');
           if (this.oControlFR.pressed)
               oValue.timeArray.push('FR');
           if (this.oControlSA.pressed)
               oValue.timeArray.push('SA');
           if (this.oControlSO.pressed)
               oValue.timeArray.push('SU');
        }
       return oValue;
    }
});
